

#    experiment run control for LyrTech - taken from sys.tcl

global MIDAS_DataAcquisitionControlServer_Verbose
set MIDAS_DataAcquisitionControlServer_Verbose 0

global env

global Options

variable SpecBase [file join $env(MIDASBASE) SpecData LyrTech]
variable SpecPath

proc Set_Options {} {
   global Options

   LoadOptions

   if {![info exists Options(Include.VHSADC)]} {set Options(Include.VHSADC) 1}
   if {![info exists Options(VHSADC.settings)]} {set Options(VHSADC.settings) 25032015}

   if {![info exists Options(VHSADC.MaxADC)]} {set Options(VHSADC.MaxADC) 16}
   if {![info exists Options(VHSADC.MaxModule)]} {set Options(VHSADC.MaxModule) 3}

   if {![info exists Options(VHSADC_GroupBase)]} {set Options(VHSADC_GroupBase) 1}

   if {![info exists Options(Rate.channels)]} {set Options(Rate.channels) 150}
   if {![info exists Options(Stat.channels)]} {set Options(Stat.channels) 150}
   if {![info exists Options(Stat.shift)]} {set Options(Stat.shift) 6}
   if {![info exists Options(Stat.offset)]} {set Options(Stat.offset) 64}

   if {![info exists Options(VHSADC.channels)]} {set Options(VHSADC.channels) 32768}
   if {![info exists Options(VHSADC.offset)]} {set Options(VHSADC.offset) 0}
   if {![info exists Options(VHSADC.shift)]} {set Options(VHSADC.shift) 1}

   if {![info exists Options(SaveClocks)]} {set Options(SaveClocks) 1}
   if {![info exists Options(SaveGains)]} {set Options(SaveGains) 1}
   if {![info exists Options(SaveUserRegs)]} {set Options(SaveUserRegs) 1}
   if {![info exists Options(SaveAcqRegs)]} {set Options(SaveAcqRegs) 0}

set Options(SaveClocks) 1
set Options(SaveGains) 1
set Options(SaveUserRegs) 1
set Options(SaveAcqRegs) 1


   if {![info exists Options(VHSADC_Hist_Trace_Enable)]} {set Options(VHSADC_Hist_Trace_Enable) 0}
   if {![info exists Options(VHSADC_Hist_Trace_channels)]} {set Options(VHSADC_Hist_Trace_channels) 1024}
   if {![info exists Options(VHSADC_Hist_Energy_Enable)]} {set Options(VHSADC_Hist_Energy_Enable) 1}
   if {![info exists Options(VHSADC_Hist_Energy_channels)]} {set Options(VHSADC_Hist_Energy_channels) 65536}
   if {![info exists Options(VHSADC_Hist_Energy_shift)]} {set Options(VHSADC_Hist_Energy_shift) 0}
   if {![info exists Options(VHSADC_Hist_BaseLine_Enable)]} {set Options(VHSADC_Hist_BaseLine_Enable) 1}
   if {![info exists Options(VHSADC_Hist_BaseLine_channels)]} {set Options(VHSADC_Hist_BaseLine_channels) 65536}
   if {![info exists Options(VHSADC_Hist_BaseLine_shift)]} {set Options(VHSADC_Hist_BaseLine_shift) 0}
   if {![info exists Options(VHSADC_Hist_Time_Enable)]} {set Options(VHSADC_Hist_Time_Enable) 0}
   if {![info exists Options(VHSADC_Hist_RAW_Enable)]} {set Options(VHSADC_Hist_RAW_Enable) 0}
   if {![info exists Options(VHSADC_Hist_RAW_channels)]} {set Options(VHSADC_Hist_RAW_channels) 2048}
   if {![info exists Options(VHSADC_Hist_Veto_Enable)]} {set Options(VHSADC_Hist_Veto_Enable) 0}
   if {![info exists Options(VHSADC_Hist_Veto_channels)]} {set Options(VHSADC_Hist_Veto_channels) 65536}
   if {![info exists Options(VHSADC_Hist_Fail_Enable)]} {set Options(VHSADC_Hist_Fail_Enable) 0}
   if {![info exists Options(VHSADC_Hist_Fail_channels)]} {set Options(VHSADC_Hist_Fail_channels) 65536}

   SaveOptions

}

namespace eval LyrTech {
    variable chanList {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15}
    variable chanID [first $chanList]
}

    variable UserReg {}
    for {set i 16} {$i <= 31} {incr i} {lappend UserReg $i}
    lappend UserReg 36
    lappend UserReg 37

    variable RegList {}
    foreach item [list 00 20 21 26 30 31 3a 3b 3c 3d 70 71 72 73 74 75 76 77 78 79 7A 80 81 83] {
       lappend RegList 0x$item
    }
    foreach item [list 90 91 92 93 94 95 96 97] {
       lappend RegList 0x$item
    }

#     MWD registers

    variable MWDReg
    for {set i 16} {$i <= 31} {incr i} {set MWDReg$i 0}
    set MWDReg36 0     ;#  TFA
    set MWDReg37 0     ;#  TFA

    for {set i 0} {$i < 13} {incr i} {variable MWDp$i 0}

#    MWD parameters

    variable RegMask
    for {set i 0} {$i <= 31} {incr i} {set RegMask($i) 0x0000ffff}
    set RegMask(36) 0x0000ffff
    set RegMask(37) 0x0000ffff

      set RegMask(16) 255
      set RegMask(17) 255
      set RegMask(20) 255
      set RegMask(21) 255
      set RegMask(24) 255
      set RegMask(25) 31
      set RegMask(26) 3


proc Dump_Raw_Data {} {

    set info "data $::DataAcquisition::ACQSERVER\n"
    
    for {set offset 0} {$offset <= 500} {incr offset 100} {
	
	DataAcqCommand 19 "Getting Raw Data" "14 $offset" 2
	set data [ReadNetVar NetVar.EXEC.Response]

        set c 0

        foreach word $data {
           set word $word
           if {$word == 0xaa5555aa} then {
               append info "\n$word - end of dump\n"
               break
           }
           if {$word == 0x55aaaa55} then {
               append info "\n"
               continue
           }
           append info "$word "
         }

	 incr c
	    
	 if {$c == 10} then {append info "\n"; set c 0}

     }

   return "$info"
}

proc create_VHSADC_spectra {} {
   global Options

   set maxadc $Options(VHSADC.MaxADC)
   set maxmodule $Options(VHSADC.MaxModule)

   set Me $::DataAcquisition::ACQSERVER
   puts "Creating spectra for $Me"

#   for the data channels

   for {set i 1} {$i <= $maxmodule} {incr i} {

     if {$Options(VHSADC_Hist_Energy_Enable) == 1} {

        for {set j 1} {$j <= $maxadc} {incr j} {   ;#    histograms for the computed energy

           set spectrumname vhsadc#$i.E$j
           puts "Creating $spectrumname"

           set z [catch {CreateSpectrum1D $spectrumname $Options(VHSADC_Hist_Energy_channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
            if {$z!=0 && $m==0x30004} then {set z 0}
            if {$z!=0} then {
              puts "Error attempting to create spectrum $spectrumname"
              error $m
            }

            set z [catch {SpectrumPutTitle $spectrumname [set Me]_$spectrumname} m]
        }
     }

     if {$Options(VHSADC_Hist_BaseLine_Enable) == 1} {

        for {set j 1} {$j <= $maxadc} {incr j} {   ;#    histograms for the base line

           set spectrumname vhsadc#$i.B$j
           puts "Creating $spectrumname"

           set z [catch {CreateSpectrum1D $spectrumname $Options(VHSADC_Hist_BaseLine_channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
            if {$z!=0 && $m==0x30004} then {set z 0}
            if {$z!=0} then {
              puts "Error attempting to create spectrum $spectrumname"
              error $m
            }

            set z [catch {SpectrumPutTitle $spectrumname [set Me]_$spectrumname} m]
        }
     }

     if {$Options(VHSADC_Hist_Trace_Enable) == 1} {

        for {set j 1} {$j <= $maxadc} {incr j} {    ;#  normal histogram to show trace buffer

           set spectrumname vhsadc#$i.ch$j
           puts "Creating $spectrumname"

           set z [catch {CreateSpectrum1D $spectrumname $Options(VHSADC_Hist_Trace_channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              display-eg-error-report self $m "Attempting to create spectrum $spectrumname"
              clear-footer
              error $m
           }

           set z [catch {SpectrumPutTitle $spectrumname [set Me]_$spectrumname} m]
        }
     }

   }   ;# end of  $i <= $maxmodule
}

proc map_VHSADC_spectra {} {
   global env
   global Options
   upvar #0 SpectraHandle f

   set Me $::DataAcquisition::ACQSERVER

   catch {file mkdir $env(MIDASTempDir)}

      set SpectraDefs [file join $env(MIDASTempDir) SpectraDefs.dat]

      set z [catch {open $SpectraDefs w} f]
      if {$z != 0} then {
          puts "Cannot open file $SpectraDefs\n$f"
          return
      }

      map_spectrum "Stat 0 0 0 $Options(Stat.shift)" 

#   for the data channels

   set maxadc $Options(VHSADC.MaxADC)
   set maxmodule $Options(VHSADC.MaxModule)

   for {set i 1} {$i <= $maxmodule} {incr i} {

     if {$Options(VHSADC_Hist_Energy_Enable) == 1} {  ;#    energy

        for {set j 1} {$j <= $maxadc} {incr j} {

           set spectrumname vhsadc#$i.E$j
           puts "Mapping $spectrumname"

           set group [expr $Options(VHSADC_GroupBase) + (($i-1)*16) + ($j-1)]
           set item 0
           map_spectrum "$spectrumname $group $item 0 $Options(VHSADC_Hist_Energy_shift)"
       }
     }

     if {$Options(VHSADC_Hist_BaseLine_Enable) == 1} {   ;#  base line

        for {set j 1} {$j <= $maxadc} {incr j} {

           set spectrumname vhsadc#$i.B$j
           puts "Mapping $spectrumname"

           set group [expr $Options(VHSADC_GroupBase) + (($i-1)*16) + ($j-1)]
           set item 1
           map_spectrum "$spectrumname $group $item 0 $Options(VHSADC_Hist_BaseLine_shift)"
       }
     }

     if {$Options(VHSADC_Hist_Trace_Enable) == 1} {

        for {set j 1} {$j <= $maxadc} {incr j} {

           set spectrumname vhsadc#$i.ch$j
           puts "Mapping $spectrumname"

           set group [expr 256 + $Options(VHSADC_GroupBase) + (($i-1)*16) + ($j-1)]
           set item 0
           map_spectrum "$spectrumname $group $item 0 0"
       }
     }
   }

   close $f
}

proc doStop {} {

puts "executing doStop for LyrTech"

     Set_Options; make-UIregisters

     Stop_Electronics

     DataAcqCommand 1 "Halt"

     if {[ReadNetVar NetVar.DACQ.Ctxenable] == 1}  {
         DataAcqCommand 1 "disconnect xfer stream #0" 0 2
     }

     if {[ReadNetVar NetVar.DACQ.Ctx2enable] == 1}  {
         DataAcqCommand 2 "disconnect xfer stream #1" 0 2
     }
}


proc doGo {} {

puts "executing doGo for LyrTech"

     Set_Options; make-UIregisters

     if {[ReadNetVar NetVar.DACQ.Ctxenable] == 1}  {
         DataAcqCommand 3 "connect xfer stream #0" 0 2
     }

     if {[ReadNetVar NetVar.DACQ.Ctx2enable] == 1}  {
         DataAcqCommand 6 "connect xfer stream #1" 0 2
     }

     Reset_Electronics

     DataAcqCommand 2 "Go"

     Go_Electronics 
}

proc doSetUp {} {
    global Options

puts "executing doSetUp for LyrTech"

     Set_Options; make-UIregisters

     DataAcqCommand 1 "Halt"

     unmap_spectra

     delete_spectra

      set Me $::DataAcquisition::ACQSERVER

      CreateSpectrum1D Stat $Options(Stat.channels)
      set z [catch {SpectrumPutTitle Stat [set Me]_Stat} m]

      CreateSpectrum1D Rate $Options(Rate.channels)
      set z [catch {SpectrumPutTitle Rate [set Me]_Rate} m]

    create_VHSADC_spectra

    map_VHSADC_spectra 

    map_spectra

    Setup_Electronics

    ParameterRestore $Options(VHSADC.settings)

    DataAcqCommand 3 "Setup"

    WriteNetVar NetVar.DACQ.PollTicks 100
    WriteNetVar NetVar.DACQ.Crdoutenable 1   ;# enable data readout

    puts "completed doSetUp"

}

   proc ParameterRestore {DBkey p} {
      global env
      global Options

       set fname [file join $env(MIDASTempDir) RestoreState.log]
       set z [catch {open $fname w} fid]
       if {$z != 0} {puts "Settings Restore logfile not created\n$fid\n"}

        puts "Restore Settings log ($DBkey $p) to $fname"
        puts $fid "Restoring Settings at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

      set ::LyrTech::DBNodeBase $DBkey
      set ::LyrTech::DBNodeName $::DataAcquisition::ACQSERVER
      
      puts $fid "Restore VHSADC settings from [set ::LyrTech::DBRootName]/[set ::LyrTech::DBNodeBase] for [set ::DataAcquisition::ACQSERVER]"
      puts "Restore VHSADC settings from [set ::LyrTech::DBRootName]/[set ::LyrTech::DBNodeBase] for [set ::DataAcquisition::ACQSERVER]"

#      set z [catch {do-restore [set ::LyrTech::DBRootName]/[set ::LyrTech::DBNodeBase]} msg]

      if {$Options(SaveClocks) == 1} {

          foreach ID $::LyrTech::boardList {

                  set offset 0x8
                  set vl [DBGetValue FpgaReg.$ID.$offset]
                  set z [catch {WriteVHSADCFpgaRegister $ID $offset $vl}]
                  if {$z == 0} {
                      puts $fid "$ID $offset [format 0x%08x $vl]"
                  } else {
                      puts $fid "Error writing FpgaReg offset=$offset: NOT restored"
                  }
          }
      }

      if {$Options(SaveGains) == 1} {

          foreach ID $::LyrTech::boardList {

             foreach offset [list 0x24 0x28 0x2c 0x30 0x34 0x38 0x3c 0x40 0x44] {

                  set vl [DBGetValue FpgaReg.$ID.$offset]
                  set z [catch {WriteVHSADCFpgaRegister $ID $offset $vl}]
                  if {$z == 0} {
                      puts $fid "$ID $offset [format 0x%08x $vl]"
                  } else {
                      puts $fid "Error writing FpgaReg offset=$offset: NOT restored"
                  }
             }
          }
      }

      if {$Options(SaveUserRegs) == 1} {

          foreach ID $::LyrTech::boardList {

             foreach offset [list 0x70 0x74 0x78 0x7c 0x100 0x104 0x108 0x10c 0x110 0x114 0x118 0x11c] {

                  set vl [DBGetValue FpgaReg.$ID.$offset]
                  set z [catch {WriteVHSADCFpgaRegister $ID $offset $vl}]
                  if {$z == 0} {
                      puts $fid "$ID $offset [format 0x%08x $vl]"
                  } else {
                      puts $fid "Error writing FpgaReg offset=$offset: NOT restored"
                  }
              }
          }
      }

      if {$Options(SaveAcqRegs) == 1} {

          foreach ID $::LyrTech::boardList {

            foreach C $::LyrTech::chanList {

                  foreach reg [list 0x00] {  ;# channel control register (per channel)
                      set vl [DBGetValue Reg$reg.$ID.$C]
                      set register [expr ($C << 28) + ($reg << 16)]
                      set z [catch {WriteVHSADCUserRegister $ID $register $vl}]
                      if {$z == 0} {
                         puts $fid "$ID $C $reg [format 0x%08x $vl]"
                      } else {
                         puts $fid "Error writing UserReg $ID $C $reg: NOT restored"
                      }
                  }
                  for {set reg 16} {$reg <= 26} {incr reg} {   ;#  MWD parameters
                      set vl [DBGetValue MWDReg$reg.$ID.$C]
                      set register [expr ($C << 28) + ($reg << 16)]
                      set z [catch {WriteVHSADCUserRegister $ID $register $vl}]
                      if {$z == 0} {
                         puts $fid "$ID $C $reg [format 0x%08x $vl]"
                      } else {
                         puts $fid "Error writing UserReg $ID $C $reg: NOT restored"
                      }
                  }
                  foreach reg [list 36 37] {   ;#  TFA parameters
                      set vl [DBGetValue MWDReg$reg.$ID.$C]
                      set register [expr ($C << 28) + ($reg << 16)]
                      set z [catch {WriteVHSADCUserRegister $ID $register $vl}]
                      if {$z == 0} {
                         puts $fid "$ID $C $reg [format 0x%08x $vl]"
                      } else {
                         puts $fid "Error writing UserReg $ID $C $reg: NOT restored"
                      }
                  }
                  foreach reg [list 0x20 0x21 0x26] {  ;# CFD Threshold, VETO control & Hit pattern  (per channel)
                      set vl [DBGetValue Reg$reg.$ID.$C]
                      set register [expr ($C << 28) + ($reg << 16)]
                      set z [catch {WriteVHSADCUserRegister $ID $register $vl}]
                      if {$z == 0} {
                         puts $fid "$ID $C $reg [format 0x%08x $vl]"
                      } else {
                         puts $fid "Error writing UserReg $ID $C $reg: NOT restored"
                      }
                  }
              }

              set C 0
              foreach reg [list 0x30 0x31] {  ;# Trace Length; PreTrigger Position(per card)
                      set vl [DBGetValue Reg$reg.$ID.$C]
                      set register [expr ($C << 28) + ($reg << 16)]
                      set z [catch {WriteVHSADCUserRegister $ID $register $vl}]
                      if {$z == 0} {
                         puts $fid "$ID $C $reg [format 0x%08x $vl]"
                      } else {
                         puts $fid "Error writing UserReg $ID $C $reg: NOT restored"
                      }
              }
              set C 0
              foreach reg [list 0x3a 0x3b 0x3c 0x3d] {   ;# TimeStamp Preload (per card)
                      set vl [DBGetValue Reg$reg.$ID.$C]
                      set register [expr ($C << 28) + ($reg << 16)]
                      set z [catch {WriteVHSADCUserRegister $ID $register $vl}]
                      if {$z == 0} {
                         puts $fid "$ID $C $reg [format 0x%08x $vl]"
                      } else {
                         puts $fid "Error writing UserReg $ID $C $reg: NOT restored"
                      }
              }
              set C 0
              foreach reg [list 0x70 0x71 0x72 0x73 0x74 0x75 0x76 0x77 0x78 0x79 0x7A] { ;# VETO + GPIO Ctrl (per card)
                      set vl [DBGetValue Reg$reg.$ID.$C]
                      set register [expr ($C << 28) + ($reg << 16)]
                      set z [catch {WriteVHSADCUserRegister $ID $register $vl}]
                      if {$z == 0} {
                         puts $fid "$ID $C $reg [format 0x%08x $vl]"
                      } else {
                         puts $fid "Error writing UserReg $ID $C $reg: NOT restored"
                      }
              }
#              set C 0
#              foreach reg [list 0x90 0x91 0x92 0x93 0x94 0x95 0x96 0x97] { ;# PSA Ctrl (per card)
#                      set vl [DBGetValue Reg$reg.$ID.$C]
#                      set register [expr ($C << 28) + ($reg << 16)]
#                      set z [catch {WriteVHSADCUserRegister $ID $register $vl}]
#                      if {$z == 0} {
#                         puts $fid "$ID $C $reg [format 0x%08x $vl]"
#                      } else {
#                         puts $fid "Error writing UserReg $ID $C $reg: NOT restored"
#                      }
#              }
          }
       }


       puts "VHSADC settings restored"
       puts $fid "VHSADC settings restored from [set ::LyrTech::DBRootName]/[set ::LyrTech::DBNodeBase] for [set ::DataAcquisition::ACQSERVER]"

#       ::LyrTech::WriteRegister HasBeenRestored 1

#        Elog INFORMATION "FEE64 settings restored from [set ::LyrTech::DBRootName]/[set ::LyrTech::DBNodeBase] for [set ::DataAcquisition::ACQSERVER]"

      close $fid

   }

   proc ParameterSave {DBkey p} {
      global env
      variable Options
      variable UserReg
      variable RegList
      variable RegMask

       set fname [file join $env(MIDASTempDir) SaveState.log]
       set z [catch {open $fname w} fid]
       if {$z != 0} {puts "Settings Save logfile not created\n$fid\n"}

        puts "Saving Settings log ($DBkey $p) to $fname"
        puts $fid "Saving Settings at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

      set ::LyrTech::DBNodeBase $DBkey
      set ::LyrTech::DBNodeName $::DataAcquisition::ACQSERVER
      
      puts $fid "Saving VHSADC settings to [set ::LyrTech::DBRootName]/[set ::LyrTech::DBNodeBase] for [set ::DataAcquisition::ACQSERVER]"
      puts "Saving VHSADC settings to [set ::LyrTech::DBRootName]/[set ::LyrTech::DBNodeBase] for [set ::DataAcquisition::ACQSERVER]"

      if {$Options(SaveClocks) == 1} {

          foreach ID $::LyrTech::boardList {

                  set offset 0x8
                  set z [catch {ReadVHSADCFpgaRegister $ID $offset} vl]
                  if {$z == 0} {
                      puts $fid "$ID $offset [format 0x%08x [expr ($vl & 7) + 0x2000]]"
                      DBSetValue FpgaReg.$ID.$offset [format "0x%02x" [expr $vl & 255]]
                  } else {
                      puts $fid "Error reading FpgaReg offset=$offset: NOT saved"
                  }
          }
      }

      if {$Options(SaveGains) == 1} {

          foreach ID $::LyrTech::boardList {

             foreach offset [list 0x24 0x28 0x2c 0x30 0x34 0x38 0x3c 0x40 0x44] {

                  set z [catch {ReadVHSADCFpgaRegister $ID $offset} vl]
                  if {$z == 0} {
                      puts $fid "$ID [format 0x%03x $offset] [format 0x%08x $vl]"
                      DBSetValue FpgaReg.$ID.$offset [format 0x%08x $vl]
                  } else {
                      puts $fid "Error reading FpgaReg offset=$offset: NOT saved"
                  }
              }
          }
      }

      if {$Options(SaveUserRegs) == 1} {

          foreach ID $::LyrTech::boardList {

             foreach offset [list 0x70 0x74 0x78 0x7c 0x100 0x104 0x108 0x10c 0x110 0x114 0x118 0x11c] {

                  set z [catch {ReadVHSADCFpgaRegister $ID $offset} vl]
                  if {$z == 0} {
                      puts $fid "$ID [format 0x%03x $offset] [format 0x%08x $vl]"
                      DBSetValue FpgaReg.$ID.$offset [format 0x%08x $vl]
                  } else {
                      puts $fid "Error reading FpgaReg offset=$offset: NOT saved"
                  }
              }
          }
      }

      if {$Options(SaveAcqRegs) == 1} {

          foreach ID $::LyrTech::boardList {

            foreach C $::LyrTech::chanList {

              set SaveID $::LyrTech::boardID
              set SaveC $::LyrTech::chanID

              set boardID $ID
              set chanID $C

              puts $fid  "Reading MWD registers for board Index $ID channel $C"

              set registers {}    ;#   build list of required registers

              foreach reg $UserReg {
                 lappend registers [expr ($C << 28) + ($reg << 16)]
              }

              foreach reg $RegList {
                 lappend registers [expr ($C << 28) + ($reg << 16)]
              }

              set z [catch {ReadVHSADCUserRegisters $ID $registers} values]   ;#  get all the values

              set index 0    ;#  extract individual registers from the list 

              foreach reg $UserReg {
                 set rc [lindex $values $index]; incr index
                 set MWDReg$reg [expr $rc & [set RegMask($reg)]]
              }

              foreach reg $RegList {
                 set rc [lindex $values $index]; incr index
                 set Reg$reg [expr $rc & 0x0000ffff]
              }

              set ::LyrTech::boardID $SaveID
              set ::LyrTech::chanID $SaveC

              if {$z == 0} {
                  foreach reg [list 0x00] {  ;# channel control register (per channel) 
                      puts $fid "$ID Reg$reg [format 0x%08x [set Reg$reg]] $C"
                      DBSetValue Reg$reg.$ID.$C [format 0x%08x [set Reg$reg]]
                  }
                  for {set reg 16} {$reg <= 26} {incr reg} {   ;#  MWD parameters
                      puts $fid "$ID MWDReg$reg [format 0x%08x [set MWDReg$reg]] $C"
                      DBSetValue MWDReg$reg.$ID.$C [format 0x%08x [set MWDReg$reg]]
                  }
                  foreach reg [list 36 37] {   ;#  TFA parameters
                      puts $fid "$ID MWDReg$reg [format 0x%08x [set MWDReg$reg]] $C"
                      DBSetValue MWDReg$reg.$ID.$C [format 0x%08x [set MWDReg$reg]]
                  }
                  foreach reg [list 0x20 0x21 0x26] {  ;# CFD Threshold, VETO control & Hit pattern  (per channel) 
                      puts $fid "$ID Reg$reg [format 0x%08x [set Reg$reg]] $C"
                      DBSetValue Reg$reg.$ID.$C [format 0x%08x [set Reg$reg]]
                  }
                  foreach reg [list 0x30 0x31] {   ;# Trace Length; PreTrigger Position(per card)
                      if {$C == 0} {puts $fid "$ID Reg$reg [format 0x%08x [set Reg$reg]] $C"; DBSetValue Reg$reg.$ID.$C [format 0x%08x [set Reg$reg]]}
                  }
                  foreach reg [list 0x3a 0x3b 0x3c 0x3d] {   ;# TimeStamp Preload (per card)
                      if {$C == 0} {puts $fid "$ID Reg$reg [format 0x%08x [set Reg$reg]] $C"; DBSetValue Reg$reg.$ID.$C [format 0x%08x [set Reg$reg]]}
                  }
                  foreach reg [list 0x70 0x71 0x72 0x73 0x74 0x75 0x76 0x77 0x78 0x79 0x7A] { ;# VETO + GPIO Ctrl (per card)
                      if {$C == 0} {puts $fid "$ID Reg$reg [format 0x%08x [set Reg$reg]] $C"; DBSetValue Reg$reg.$ID.$C [format 0x%08x [set Reg$reg]]}
                  }
#                 foreach reg [list 0x90 0x91 0x92 0x93 0x94 0x95 0x96 0x97] { ;# PSA Ctrl (per card)
#                      if {$C == 0} {puts $fid "$ID Reg$reg [format 0x%08x [set Reg$reg]] $C"; DBSetValue Reg$reg.$ID.$C [format 0x%08x [set Reg$reg]]}
#                  }

              } else {
                  puts $fid "Error reading MWD parameters: NOT saved"
              }
            }
          }
      }




      puts $fid "VHSADC settings saved to [set ::LyrTech::DBRootName]/[set ::LyrTech::DBNodeBase] for [set ::DataAcquisition::ACQSERVER]"
      puts  "VHSADC settings saved"

#       ::LyrTech::WriteRegister HasBeenRestored 1

#        Elog INFORMATION "FEE64 settings saved to [set ::LyrTech::DBRootName]/[set ::LyrTech::DBNodeBase] for [set ::DataAcquisition::ACQSERVER]"


        puts "Settings saved at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

        close $fid

   }


proc Reset_Electronics {} {    ;#   used by RESET

}

proc Setup_Electronics {} {    ;#   used by SETUP

}

proc Stop_Electronics {} {

#    inform vhsadc do_acqGO 0

}

proc Go_Electronics {} {

#    inform vhsadc do_acqGO 1

}

 proc SpecSave1D {spec base range type title counts} {
    global tcl_platform
    variable SpecPath

      set f3 [file join $SpecPath $spec.msf]
      set z1 [catch {open $f3 w} m1]
      if {$z1 != 0} then {puts "Cannot create $f3 - $m1"}

      if {$tcl_platform(platform) != "windows"} {
           set z2 [catch {file attributes $f3 -permissions rwxrwxrwx} m2]
           if {$z2 != 0} then {puts "error accessing $f3 - $m2"}
      }

      set f $m1

      fconfigure $f -translation binary -encoding binary

  set ctime [clock format [clock seconds] -format {%d-%b-%Y %H:%M:%S}]
  set mtime [clock format [clock seconds] -format {%d-%b-%Y %H:%M:%S}]

      puts -nonewline $f [binary format i1 412900921]   ;#   magic number
      puts -nonewline $f [binary format i1 1]           ;#   version
      puts -nonewline $f [binary format a32 $spec]      ;#   spectrum name
      puts -nonewline $f [binary format i1 1]           ;#   dimension
      puts -nonewline $f [binary format a20 $ctime]     ;#   creation time/date
      puts -nonewline $f [binary format a20 $mtime]     ;#   modification time/date
      puts -nonewline $f [binary format i1 $base]       ;#   base0

      for {set i 2} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#   baseI
      }

      puts -nonewline $f [binary format i1 $range]    ;#   range0

      for {set i 2} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#   rangeI
      }

      puts -nonewline $f [binary format i1 -1]        ;#   spectrum title offset

      for {set i 2} {$i <=32} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  information pointers
      }

      for {set i 1} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  annotation pointers
      }

      for {set i 1} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  calibration pointers
      }

      for {set i 1} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  efficiency pointers
      }

                                                     ;#  data array 1 descriptor 
      puts -nonewline $f [binary format i1 0]        ;#  array layout
      puts -nonewline $f [binary format i1 $type]    ;#  array type  (32 bit unsigned)
      puts -nonewline $f [binary format i1 0]        ;#  reserved 
      puts -nonewline $f [binary format i1 0]        ;#  reserved
      puts -nonewline $f [binary format i1 0]        ;#  spectrum counts offset

                                                     ;#  data array 2 descriptor 
      puts -nonewline $f [binary format i1 0]        ;#  array layout
      puts -nonewline $f [binary format i1 $type]    ;#  array type 
      puts -nonewline $f [binary format i1 0]        ;#  reserved 
      puts -nonewline $f [binary format i1 0]        ;#  reserved
      puts -nonewline $f [binary format i1 -1]       ;#  spectrum counts offset

      puts -nonewline $f [binary format i1 436]      ;#  base of string space
      puts -nonewline $f [binary format i1 20]       ;#  string free space
      puts -nonewline $f [binary format i1 76]       ;#  top of string space

      puts -nonewline $f [binary format i1 512]      ;#  base of counts space
      puts -nonewline $f [binary format i1 $range]   ;#  string free space
      puts -nonewline $f [binary format i1 $range]   ;#  top of string space
 
      puts -nonewline $f [binary format a20 $title]  ;# string space - title

      for {set i 456} {$i < 512} {incr i} {
         puts -nonewline $f [binary format c1 0]     ;#  unused
      }

      puts -nonewline $f [binary format i* $counts]  ;# counts

      close $f
}

    proc HistogramSave {args} {
       global env
       global tcl_platform
       variable SpecBase
       variable SpecPath

       set fname [file join $env(MIDASTempDir) HistogramSave.log]
       set z [catch {open $fname w} fid]
       if {$z != 0} {puts "Histogram Save logfile not created\n$fid\n"}

        puts "Saving  Histograms"
        puts $fid "Saving  Histograms at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

      set f1 $SpecBase
      set z1 [catch {file mkdir $f1} m1]
      if {$z1 != 0} then {puts $fid "Cannot create $f1 - $m1"}

      if {$tcl_platform(platform) != "windows"} {
           set z2 [catch {file attributes $f1 -permissions rwxrwxrwx} m2]
           if {$z2 != 0} then {puts "error accessing $f1 - $m2"}
      }

      set f1 [file join $f1 $env(ComputerName)]
      set z1 [catch {file mkdir $f1} m1]
      if {$z1 != 0} then {puts $fid "Cannot create $f1 - $m1"}

      if {$tcl_platform(platform) != "windows"} {
           set z2 [catch {file attributes $f1 -permissions rwxrwxrwx} m2]
           if {$z2 != 0} then {puts "error accessing $f1 - $m2"}
      }

      set f2 [file join $f1 [date +%Y%h%d-%H.%M.%S]]
      set z1 [catch {file mkdir $f2} m1]
      if {$z1 != 0} then {puts $fid "Cannot create $f2 - $m1"}

      if {$tcl_platform(platform) != "windows"} {
           set z2 [catch {file attributes $f2 -permissions rwxrwxrwx} m2]
           if {$z2 != 0} then {puts "error accessing $f2 - $m2"}
      }

       set SpecPath $f2

       set SpecNames [SpectrumNames]
       set NumSpec 0

      foreach item $SpecNames {
         if {[first $item] != 1} {continue}   ;#   not a 1D histogram !!

         set SpecName [second $item]
         set spec [last [split $SpecName .]]

         set info [SpectrumDetails $SpecName]
         set channels [lindex $info 2]

         set title [SpectrumGetTitle $SpecName]
         set counts [SpectrumRead1D $SpecName 0 $channels]

         set z [catch {SpecSave1D $SpecName 0 $channels 5 $title $counts} m]
         if {$z!=0} then {
             puts $fid "Error attempting to save spectrum $SpecName: $m"
         } else {
             incr NumSpec
         }
      }

        puts "$NumSpec Histograms saved"
        puts $fid "$NumSpec Histograms saved at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

        close $fid

    }

    proc HistogramZero {} {

       set SpecNames [SpectrumNames]
       set NumSpec 0

       ZeroSpectrum Stat
       incr NumSpec

      foreach item $SpecNames {
         if {[first $item] != 1} {continue}   ;#   not a 1D histogram !!

         set SpecName [second $item]

         ZeroSpectrum $SpecName
         incr NumSpec
      }

       puts "$NumSpec spectra zeroed"
    }

    proc DumpRawData {} {Dump_Raw_Data}
 
    proc TerminateExec {} {

        unmap_spectra
        DataAcqCommand 22 "Terminating DataAcq program" 0 2

    }

    proc LoadExec {} {
       global Options
       global env

    }

    make-UIregisters

    Set_Options



