
#    Note:  This is loaded into the namespace  LyrTech_SpecSave

 variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

#     do_DBUpdate
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable Project [set ::DataAcquisition::PROJECT]

    global env
    variable SpecBase [file join $env(MIDASBASE) SpecData $Project]

   variable index 0
   variable selected -1
   variable brdselected 255

   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable selected
        variable brdselected
        variable Project

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "selected=$selected"
        InsertLog "DBPath = [set ::[set Project]::DBRootName]/[set ::[set Project]::DBNodeBase]/[set ::[set Project]::DBNodeName]"

        foreach item [set ::[set Project]::ModuleList] {InsertLog "$item"}

#        InsertLog "HasBeenConfigured = [ReadRegister HasBeenConfigured]"
#        InsertLog "HasBeenRestored = [ReadRegister HasBeenRestored]"
   }

      proc Selection {} {
          variable selected
          variable Project

           set i 1
           foreach item [set ::[set Project]::crateList] {
               set selected [expr $selected | (1 << $i)]
               incr i
           }
      }

      proc do_Select {i} {
         variable selected

         set selected [expr $selected | (1 << $i)]
      }

      proc do_UnSelect {i} {
         variable selected

         set selected [expr $selected & ~(1 << $i)]
      }

      proc do_Save {} {
          variable SpecBase
	  variable selected
          variable Project
	  
	  if {$selected == 0} {Selection}
	  
	  InsertLog "Saving VHSADC histograms to $SpecBase"
	  
	  set BAK $::DataAcquisition::ACQSERVER   ;# save
	  
	  set i 0
	  foreach item [set ::[set Project]::crateList] {
	      incr i
	      if {[expr ($selected >> $i) & 1] == 0} {continue}
	      
	      set ::DataAcquisition::ACQSERVER $item
	      DAQ_DoOption "HistogramSave=$SpecBase"
	      
	      InsertLog "VHSADC histograms saved for $::DataAcquisition::ACQSERVER"
	  }
	  
	  set ::DataAcquisition::ACQSERVER $BAK    ;# restore
	  
	  InsertLog "VHSADC histograms saved"
	  
	  #        Elog INFORMATION "VHSADC histograms saved to [set ::[set Project]::DBRootName]/[set ::[set Project]::DBNodeBase]"
	  
	  #        do_DBUpdate
      }
    
    proc do_DBName {vl} {
	global Options
        variable Project
	
	set ::[set Project]::DBNodeBase $vl
	DBCreateNode [set ::[set Project]::DBRootName]/[set ::[set Project]::DBNodeBase]
	
	InsertLog "Data Base node [set ::[set Project]::DBRootName]/[set ::[set Project]::DBNodeBase] contains [DBGetNodes [set ::[set Project]::DBRootName]/[set ::[set Project]::DBNodeBase] *]"
    }
    
    proc do_DBUpdate {} {
	variable DBNameList
        variable Project
	
	set DBNameList {}
	foreach item [DBGetNodes [set ::[set Project]::DBRootName] *] {
	    if {$item == "Options"} continue
	    lappend DBNameList $item
	}
    }
    
    
    proc  do_click {}  {
	variable cgidata
	variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {variable selected; if {$selected == 0} {Selection}}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                DBNAMES -
                DBNAME   {do_DBName [lindex $w 1]}

                GENKEY   {do_DBName [date +%Y%h%d-%H.%M.%S]}

                SAVE     {do_Save}
      
                SELECT    {do_Select [lindex $w 1]}
                UNSELECT  {do_UnSelect [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }

   Selection

#     do_DBUpdate

#     load_Options
#     set ::LyrTech::DBNodeBase $Options(ASIC.settings)
#     set ::LyrTech::DBNodeBase Histograms


}  ;# end of if {$started == 0}

