

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable boardID 0
    variable numchans 16
    variable channelList {}
    for {set i 0} {$i < $numchans} {incr i} {lappend channelList $i}
    variable channelID 0

    variable UserLabel "test lab"

    variable Fmajor 1
    variable Fminor 0
    variable Fday 1
    variable Fmonth 1
    variable Fyear 1900

    variable allchannels 0

    for {set i 1} {$i <= $numchans} {incr i} {variable A$i; set A$i 0}

    for {set i 1} {$i <= 25} {incr i} {variable P$i; set P$i 0}
    for {set i 1} {$i <= 8} {incr i} {variable P23$i; set P23$i 0}

    variable ADCClockFreq 105.0

    variable clock_frequency      105.0
    variable decimation_factor    4
    variable shaping_time         6.0
    variable trapezoid_width      4.4
    variable peak_separation      8.5
    variable decay_time_constant  50.0
    variable peak_sample_time     7.2
    variable baseline_update_time 2
    variable baseline_average     4
    variable baseline_threshold   16384
    variable mode                 0
    variable tfa_shaping_time     120.0
    variable tfa_decay_time       50000.0  


#     MWD registers

    variable MWDReg
    for {set i 16} {$i <= 31} {incr i} {set MWDReg($i) 0}
    set MWDReg(36) 0     ;#  TFA
    set MWDReg(37) 0     ;#  TFA

    for {set i 0} {$i < 13} {incr i} {variable MWDp$i 0}

#    MWD parameters

    variable RegMask
    for {set i 0} {$i <= 31} {incr i} {set RegMask($i) 0x0000ffff}
    set RegMask(36) 0x0000ffff
    set RegMask(37) 0x0000ffff

      set RegMask(16) 255
      set RegMask(17) 255
      set RegMask(20) 255
      set RegMask(21) 255
      set RegMask(24) 255
      set RegMask(25) 31
      set RegMask(26) 3

    variable UserReg {}
    for {set i 16} {$i <= 31} {incr i} {lappend UserReg $i}
    lappend UserReg 36
    lappend UserReg 37


    variable Reg0x00 0     ;#  control register
    variable Reg0x20 0     ;#  CFD Threshold
    variable Reg0x21 0     ;#  Veto Control
    variable Reg0x26 0     ;#  Hit pattern trigger mask
    variable Reg0x30 0     ;#  Trace length 
    variable Reg0x31 0     ;#  PreTrigger Position
    variable Reg0x3a 0
    variable Reg0x3b 0
    variable Reg0x3c 0
    variable Reg0x3d 0
    variable Reg0x70 0    ;# TDRI Control
    variable Reg0x71 0    ;# Veto Coincidence window
    variable Reg0x72 0    ;# GPIO Control
    variable Reg0x73 73    ;# VETO delay
    variable Reg0x74 74    ;# VETO delay
    variable Reg0x75 75    ;# VETO delay
    variable Reg0x76 76    ;# VETO delay
    variable Reg0x77 77    ;# VETO delay
    variable Reg0x78 78    ;# VETO delay
    variable Reg0x79 79    ;# VETO delay
    variable Reg0x7A 80    ;# VETO delay

    variable Reg0x80 0
    variable Reg0x81 0
    variable Reg0x83 0

    variable Reg0x90 0     ;#  PSA registers
    variable Reg0x91 0
    variable Reg0x92 0
    variable Reg0x93 0
    variable Reg0x94 0
    variable Reg0x95 0
    variable Reg0x96 0
    variable Reg0x97 0

    variable RegList {}
    foreach item [list 00 20 21 26 30 31 3a 3b 3c 3d 70 71 72 73 74 75 76 77 78 79 7A 80 81 83] {
       lappend RegList 0x$item
    }
#    foreach item [list 90 91 92 93 94 95 96 97] {
#       lappend RegList 0x$item
#    }

    variable TraceLenMenu [list 0 24 56 120 248 504 1016 2040]

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg
        variable RegList
        variable UserReg
        variable MWDReg
       variable RegMask
        variable boardID
        variable channelID
        variable allchannels

       foreach reg $RegList {variable Reg$reg}

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "board=$boardID; channel=$channelID; allchannels=$allchannels"
        InsertLog "Rmsg=$Rmsg"
        InsertLog "Wmsg=$Wmsg"

        set values [Read_MWD_Registers];  
        set index 0

  InsertLog "showing registers"

       foreach reg $UserReg {
          set rc [lindex $values $index]; incr index
          set MWDReg($reg) [expr $rc & $RegMask($reg)]
          InsertLog "MWDReg $reg = [set MWDReg($reg)]"
       }

       foreach reg $RegList {
          set rc [lindex $values $index]; incr index
          set Reg$reg [expr $rc & 0x0000ffff]
          InsertLog "Reg$reg = [set Reg$reg]"
       }

       update_GUI
   }

    proc update_GUI {} {
        variable RegList
        variable TraceLenMenu
       
       foreach reg $RegList {variable Reg$reg}

InsertLog "update_GUI"

    for {set i 1} {$i <= 24} {incr i} {variable P$i}

       variable Fmajor
       variable Fminor
       variable Fday
       variable Fmonth
       variable Fyear

         set P1 [expr ($Reg0x00 >> 0) & 1]      ;#   channel enable
         set P4 [expr ($Reg0x00 >> 4) & 1]      ;#   trigger polarity
         set P10 [expr ($Reg0x00 >> 8) & 3]     ;#   AI digital gain
         set P12 [expr ($Reg0x00 >> 5) & 7]      ;#   analogue inspection  
         set P14 [expr ($Reg0x00 >> 1) & 1]      ;#   baseline subtraction
         set P16 [expr ($Reg0x00 >> 2) & 3]      ;#   energy digital gain
         set P7  [expr ($Reg0x00 >> 10) & 3]       ;#   trigger mode

        set P2 $Reg0x20                            ;#   CFD threshold

        set Fday [expr ((($Reg0x83 >> 12) & 15) * 16) + (($Reg0x83 >> 8) & 15)]
        set Fmonth [expr ($Reg0x83 >> 4) & 15]
        set Fyear [expr ($Reg0x83 & 15) + 2000]   ;#   firmware build date

         set Fmajor [expr ($Reg0x80 & 0x0000ffff)]
         set Fminor [expr ($Reg0x81 & 0x0000ffff)]  ;#   firmware version

         set P21 [expr ($Reg0x71 >> 15) & 1]        ;#  Veto Window enable
         set P22 [expr ($Reg0x71 >> 14) & 1]        ;#  early Veto Window enable
         set P23 [expr $Reg0x71 & 0x3fff]           ;#  Veto Coinc Window (10ns)
         set P24 $Reg0x31                           ;#  pre trigger position

         set P20 [lsearch $TraceLenMenu [expr ($Reg0x30 * 2) - 8]]   ;# trace length

         set P19 [expr ($Reg0x72 >> 1) & 15]        ;#  GPIO signal channel select

         set R 115     ;#   0x73               ;#  Veto delays
         for {set i 1} {$i <= 8} {incr i} {
             set P [set Reg0x[format "%02X" $R]]
             set Reg0x[format "%02X" $R] [expr 0x04ff & $P]
             incr R
         }

   }


    proc Read_MWD_Registers {} {
       variable boardID
       variable channelID
       variable MWDReg
       variable RegMask
       variable UserReg
       variable RegList

       foreach reg $RegList {variable Reg$reg}

InsertLog "Read_MWD_Registers"

       set registers {}    ;#   build list of required registers

       foreach reg $UserReg {
         lappend registers [expr ($channelID << 28) + ($reg << 16)]
       }

       foreach reg $RegList {
         lappend registers [expr ($channelID << 28) + ($reg << 16)]
       }

       set values [ReadVHSADCUserRegisters $boardID $registers] ;#  get all the values

       set index 0

       foreach reg $UserReg {
          set rc [lindex $values $index]; incr index
          set MWDReg($reg) [expr $rc & $RegMask($reg)]
       }

       foreach reg $RegList {
          set rc [lindex $values $index]; incr index
          set Reg$reg [expr $rc & 0x0000ffff]
       }

      return $values

    }

    proc Set_MWD_Registers {} {

        update_mwd_parameters
        apply_mwd_parameters
    }


proc apply_mwd_parameters {} {

#    this sets the MWD registers from the values of the MWD parameters

    variable ADCClockFreq

    variable clock_frequency
    variable decimation_factor
    variable shaping_time
    variable trapezoid_width
    variable peak_separation
    variable decay_time_constant
    variable peak_sample_time
    variable baseline_update_time
    variable baseline_average
    variable baseline_threshold
    variable mode
    variable tfa_shaping_time
    variable tfa_decay_time

    variable MWDReg

    for {set i 0} {$i < 13} {incr i} {variable MWDp$i }

   InsertLog "apply_mwd_parameters"

    if {$ADCClockFreq != "External"} {
        if {$clock_frequency != $ADCClockFreq} {set clock_frequency $ADCClockFreq;  update_mwd_parameters}
    }

    set clock_width [expr 1000000000 / ( [set clock_frequency] * 1000000 ) ]
    set ddt [expr $clock_width * 0.001 * $decimation_factor ]
    set dt [expr $clock_width * 0.001 ]
    set Mbydt [expr $shaping_time / $ddt]

    set MWDReg(16) [expr round(256 - $Mbydt +1)]                             ;# R16
    set MWDReg(17) [expr 256 - round($trapezoid_width / $ddt ) -1]           ;# R17
    set MWDReg(18) [expr int($peak_sample_time / $dt)]                       ;# R18
    set MWDReg(19) [expr int( $peak_separation / $dt ) ]                     ;# R19
    set MWDReg(20) $baseline_average                                         ;# R20
    set MWDReg(21) [expr round($baseline_update_time / $ddt)]                ;# R21
    set MWDReg(22) $baseline_threshold                                       ;# R22

    set z [catch {expr round(16777216 * (1 - exp([expr - $shaping_time / $decay_time_constant])) / $Mbydt)} m]    ;# R23
    if {$z != 0} {alert "Unacceptable data value"; return}
    set MWDReg(23) $m

    set MWDReg(25) [expr 32 - $decimation_factor +1]                         ;# R25
    set MWDReg(26) $mode                                                    ;# R26

    set z [catch {expr round(256-($tfa_shaping_time*1.0/10))} m]
    if {$z != 0} {alert "Unacceptable data value"; return}
    set MWDReg(37) $m

    set z [catch {expr round(0x01000000 * (1-exp(-$tfa_shaping_time*1.0/$tfa_decay_time))/($tfa_shaping_time/10))} m]
    if {$z != 0} {alert "Unacceptable data value"; return}
    set MWDReg(36) $m

}


proc update_mwd_parameters {} {

#    this sets the MWD parameters from the values of the MWD registers -  MWDReg(*)

    variable ADCClockFreq

    variable clock_frequency
    variable decimation_factor
    variable shaping_time
    variable trapezoid_width
    variable peak_separation
    variable decay_time_constant
    variable peak_sample_time
    variable baseline_update_time
    variable baseline_average
    variable baseline_threshold
    variable mode
    variable tfa_shaping_time
    variable tfa_decay_time

    variable MWDReg

  InsertLog "update_mwd_parameters"

    if {$ADCClockFreq != "External"} {
        if {$clock_frequency != $ADCClockFreq} {set clock_frequency $ADCClockFreq;  apply_mwd_parameters}
    }

    set clock_width [expr 1000000000 / ( [set clock_frequency] * 1000000 ) ]
    set decimation_factor [expr 33 - $MWDReg(25)]
    set ddt [expr $clock_width * 0.001 * $decimation_factor ]
    set dt [expr $clock_width * 0.001 ]
    set shaping_time [expr (257 - $MWDReg(16)) * $ddt]
    set Mbydt [expr $shaping_time / $ddt]

#    set shaping_time [expr 257 - $MWDReg(16)]
    set trapezoid_width [expr (255 - $MWDReg(17)) * $ddt]
    set peak_sample_time [expr $MWDReg(18) * $dt]
    set peak_separation [expr $MWDReg(19) * $dt]
    set baseline_average $MWDReg(20)
    set baseline_update_time [expr $MWDReg(21) * $ddt]
    set baseline_threshold $MWDReg(22)
    set p1 [expr ($MWDReg(23)*$Mbydt)/16777216]
    set p2 [expr 1/(1-$p1)]
    set decay_time_constant [expr $shaping_time/log($p2)]
#    set decimation_factor [expr 33 - $MWDReg(25)]
    set mode $MWDReg(26)
    set tfa_shaping_time [expr (256-$MWDReg(37))*10] 
#    set tfa_decay_time  [expr $tfa_shaping_time/log(1.0/(1-($MWDReg(36)*($tfa_shaping_time/10)*1.0)/0x1000000))]

}


    proc applychannelsettings {} {
       variable channelID
       variable RegList
       variable MWDReg

       foreach reg $RegList {variable Reg$reg}

   InsertLog "applychannelsettings"

#    write settings to the hardware for the current channel

       WriteVHSADCUserRegister $channelID 0x00 [set Reg0x00]    ;#   channel control register

       for {set reg 16} {$reg <= 26} {incr reg} {               ;#   MWD registers
          WriteVHSADCUserRegister $channelID $reg [set MWDReg($reg)] 
       }

       for {set reg 36} {$reg <= 37} {incr reg} {               ;#   TFA registers
          WriteVHSADCUserRegister $channelID $reg [set MWDReg($reg)] 
       }

       foreach reg {0x20 0x21 0x26} {               ;#  CFD threshold; VETO control
          WriteVHSADCUserRegister $channelID $reg [set Reg$reg] 
       }

       if {$channelID == 0} {       ;#   following registers are per card 

          WriteVHSADCUserRegister $channelID 0x30 [set Reg0x30]  ;# Trace length
          WriteVHSADCUserRegister $channelID 0x31 [set Reg0x31]  ;# PreTrigger Position

          foreach reg {0x3a 0x3b 0x3c 0x3d} {               ;#  timestamp preload
             WriteVHSADCUserRegister $channelID $reg [set Reg$reg] 
          }

          foreach reg {0x70 0x71 0x72 0x73 0x74 0x75 0x76 0x77 0x78 0x79 0x7A} {   ;#   VETO + GPIO Ctrl
             WriteVHSADCUserRegister $channelID $reg [set Reg$reg] 
          }

#          foreach reg {0x90 0x91 0x92 0x93 0x94 0x95 0x96 0x97} {   ;#   PSA Ctrl
#             WriteVHSADCUserRegister $channelID $reg [set Reg$reg] 
#          }
       }

       if {[expr $Reg0x00 & 1] == 0} {  ;# channel enabled so needs a reset
             WriteVHSADCUserRegister $channelID 0x00 [expr $Reg0x00 | 1]       
             WriteVHSADCUserRegister $channelID 0x00 $Reg0x00
       }
   }

    proc ApplySettings {} {
       variable channelList
       variable channelID
       variable allchannels

       set crateList [set ::LyrTech::crateList]
       set boardList [set ::LyrTech::boardList]

       set crateID [set ::LyrTech::crateID]
       set boardID [set ::LyrTech::boardID]

       set allcrates $::LyrTech::allcrates
       set allboards $::LyrTech::allboards

       set save1 $crateID
       set save2 $boardID

       foreach crate [set ::LyrTech::crateList] {
         if {$allcrates == 0 && $crate != $crateID} {continue}
         SelectVHSADCCrate $crate
         foreach board [set ::LyrTech::boardList] {
           if {$allboards == 0 && $board != $boardID} {continue}
           SelectVHSADCBoard $board
           foreach channel $channelList {
             if {$allchannels == 0 && $channel != $channelID} {continue}

             InsertLog "Update crate=$crate board=$board channel=$channel"

             applychannelsettings
           }
         }
       }
       SelectVHSADCCrate $save1
       SelectVHSADCBoard $save2

       Set_MWD_Registers
    }


    proc UpdateModule {} {
       variable channelList
       variable channelID
       variable allchannels
       variable RegList

       variable Fmajor
       variable Fminor
       variable Fday
       variable Fmonth
       variable Fyear


         set Fmajor [expr [ReadVHSADCUserRegister [set ::LyrTech::boardID] 0x80] & 0x0000ffff]
         set Fminor [expr [ReadVHSADCUserRegister [set ::LyrTech::boardID] 0x81] & 0x0000ffff]

         set date  [ReadVHSADCUserRegister [set ::LyrTech::boardID] 0x83]

         set Fday   [expr ((($date >> 12)&15)*16) + (($date >> 8)&15)]
         set Fmonth [expr ($date >> 4) & 15]
         set Fyear  [expr ($date & 15) + 2000]

       set crateList [set ::LyrTech::crateList]
       set boardList [set ::LyrTech::boardList]
       set regList $RegList

       set crateID [set ::LyrTech::crateID]
       set boardID [set ::LyrTech::boardID]

       set allcrates $::LyrTech::allcrates
       set allboards $::LyrTech::allboards

       set save1 $crateID
       set save2 $boardID

       foreach crate [set ::LyrTech::crateList] {
         if {$allcrates == 0 && $crate != $crateID} {continue}
         SelectVHSADCCrate $crate
         foreach board [set ::LyrTech::boardList] {
           if {$allboards == 0 && $board != $boardID} {continue}
           SelectVHSADCBoard $board
           foreach channel $channelList {
             if {$allchannels == 0 && $channel != $channelID} {continue}

             InsertLog "Update crate=$crate board=$board channel=$channel"

             foreach reg $regList {
                set rc [ReadVHSADCUserRegister $boardID $reg]

                variable Reg[set reg]; set Reg[set reg] $rc

                InsertLog "Update register $rc =>  Reg[set reg]"
             }


           }
         }
       }
       SelectVHSADCCrate $save1
       SelectVHSADCBoard $save2

     }



    proc do_Offset {p vl} {InsertLog "Offset $p = $vl"

#       variable $p; set $p $vl

      switch $p {
        1 -
        2 -
        3 -
        4 -
        5 -
        6 -
        7 -
        8  {variable Reg0x[format "%02X" [expr $p+114]]; set Reg0x[format "%02X" [expr $p+114]] $vl}
        9  {variable Reg0x20; set Reg0x20 $vl; variable P2; set P2 $vl}
       10  {variable Reg0x71; set Reg0x71 $vl;variable P23; set P23 $vl}
       11  {variable Reg0x31; set Reg0x31 $vl; variable P24; set P24 $vl}
        default {}
      }
    }


    proc do_Setting {p vl} {InsertLog "Setting $p = $vl"
    
#    convert variable name from new to previous scheme
    
        switch -glob $p {
           Choice*      {set p [string range $p 6 end]}
           rangeInputS* {set p [string range $p 11 end]}
           textInputS*  {set p [string range $p 10 end]}
        }

#  P1   channel   enable/disable
#  P2   CFD threshold
#  P3   base line average
#  P4   trigger polarity  +ve/-ve
#  P5   TFA shaping time
#  P6   base line update time
#  P7   trigger mode     0=>3
#  P8   shaping time
#  P9   base line threshold
#  P10  AI digital gain    0=>3
#  P11  Rise time
#  P12  analogue inspection   0=>7
#  P13  peak sample
#  P14  base line subtraction   on/off
#  P15  peak separation
#  P16  energy digital gain     0=>3
#  P17  decay time constant
#  P18  TDRI DAC channel select
#  P19  GPIO signal channel select
#  P20  trace length
#  P21  pretrigger position
#  P22  veto window
#  P231 => P238  veto delays
#  P24  early veto window
#  P25  Veto coinc window


      switch $p {
        P3   {variable baseline_average; set baseline_average $vl}
        P5   {variable tfa_shaping_time; set tfa_shaping_time $vl}
        P6   {variable baseline_update_time; set baseline_update_time $vl}
        P8   {variable shaping_time; set shaping_time $vl}
        P9   {variable baseline_threshold; set baseline_threshold $vl}
        P13  {variable peak_sample_time; set peak_sample_time $vl}
        P17  {variable decay_time_constant; set decay_time_constant $vl}
        default {}
      }
      
      switch $p {
        P231 -
        P232 -
        P233 -
        P234 -
        P235 -
        P236 -
        P237 -
        P238 {
           set r [expr [string range $p 1 end] - 230 + 114]
           variable Reg0x[format "%02X" $r]; set Reg0x[format "%02X" $r] $vl
        }
        P5   {}
        P21  {}
        P25  {}
        default {}
      }

       variable $p; set $p $vl
       
       InsertLog "$p  $vl"

    }



    proc do_Apply {p} {InsertLog "Apply $p"

#       variable $p; set $p $vl

    }

    proc do_Execute {} {InsertLog "Execute....."
        variable boardID
        variable channelID
        variable Reg0x00
        variable Reg0x20

#       variable $p; set $p $vl

    for {set i 1} {$i <= 24} {incr i} {variable P$i}

        set Settings {}

        set reg 0x00
        set Reg0x00 [expr ($Reg0x00 & 0xfffe) | ($P1 << 0)]   ;#  channel  enable/disable
        lappend Settings [expr ($channelID << 28) + ($reg << 16) + $Reg0x00]

        set reg 0x00
        set Reg0x00 [expr ($Reg0x00 & 0xfffd) | ($P14 << 1)]   ;#  base line subtraction
        lappend Settings [expr ($channelID << 28) + ($reg << 16) + $Reg0x00]

        set reg 0x00
        set Reg0x00 [expr ($Reg0x00 & 0xfff3) | ($P16 << 2)]   ;#  energy digital gain
        lappend Settings [expr ($channelID << 28) + ($reg << 16) + $Reg0x00]

        set reg 0x00
        set Reg0x00 [expr ($Reg0x00 & 0xffef) | ($P4 << 4)]   ;#  trigger polarity
        lappend Settings [expr ($channelID << 28) + ($reg << 16) + $Reg0x00]

        set reg 0x00
        set Reg0x00 [expr ($Reg0x00 & 0xff1f) | ($P12 << 5)]   ;#  analogue inspection
        lappend Settings [expr ($channelID << 28) + ($reg << 16) + $Reg0x00]

        set reg 0x00
        set Reg0x00 [expr ($Reg0x00 & 0xfcff) | ($P10 << 8)]   ;#  AI digital gain
        lappend Settings [expr ($channelID << 28) + ($reg << 16) + $Reg0x00]

        set reg 0x00
        set Reg0x00 [expr ($Reg0x00 & 0xe3ff) | ($P7 << 10)]   ;#  trigger mode
        lappend Settings [expr ($channelID << 28) + ($reg << 16) + $Reg0x00]

        set reg 0x20
        set Reg0x20 $P2   ;#  CFD threshold
        lappend Settings [expr ($channelID << 28) + ($reg << 16) + $Reg0x20]

        set z [catch {WriteVHSADCUserRegisters $channelID $Settings} m]
        if {$z == 0} {InsertLog "Applied Settings to board $boardID channel $channelID"}
        if {$z != 0} {InsertLog "Error applying Settings to board $boardID channel $channelID: rc=$z; m=$m"}

        ApplySettings
    }


     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]
               set i [second [lindex $cgidata 1]]
               set vl [third [lindex $cgidata 1]]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {UpdateModule;   update_GUI}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   CRATE     {SelectVHSADCCrate $i}
                   ALLCRATES {set ::LyrTech::allcrates [expr ($::LyrTech::allcrates + 1) & 1]}
                   BOARD     {SelectVHSADCBoard $i}
                   ALLBOARDS {set ::LyrTech::allboards [expr ($::LyrTech::allboards + 1) & 1]}
                   CHANNEL   {variable channelID; set channelID $i}
                   ALLCHANNELS {variable allchannels; set allchannels [expr ($allchannels + 1) & 1]}

                   SETTINGS  {do_Setting $i $vl}
                   APPLY     {do_Apply $i}
                   EXECUTE   {set z [catch {do_Execute} m]; InsertLog "do_Execute returned $z $m"}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
#               UpdateModule
           }
       }
    }

}   ;# end of if {$started == 0}

