


set Menu1 {}
for {set i 0} {$i <= 15} {incr i} {lappend Menu1 $i}

set Menu2 {}
for {set i 0x00} {$i <= 0x9f} {incr i} {lappend Menu2 [format 0x%02x $i]}

set Apply 0

proc make_GUI {} {
    global UserGUIVersion
    global user10 user11 user12
    global user90 user91 user92
    global numchans chan ChanMenu allchans allmodules
    global Menu1 Menu2

   global Options Customcfgfile
   global UserReg RegMask

#    GUI interface for MWD firmware
 
  :frame "[self frame-name].user" :label "Firmware Parameter Control (Expert Level)" :resize F 

   :panel MODULE  :layout T :padx 10 :pady 10
     :layout H; :row-gap 10; :col-gap 10

    :number CRT-NUM  :label "Crate Number:" :w 2
    :number MOD-NUM :label "Board Number:" :min -1 :max -1 :w 2 :value -1
    :menubutton MOD-SEL :label "" :menu "none"

if {$UserGUIVersion != 2} {     ;#   MWD firmware
     :number CHAN-NUM  :label "Channel Number:" :min 1 :max $numchans :w 3 :value $chan
     :menubutton CHAN-SEL :label "select:" :strings $ChanMenu
} else {
     :message VERSION :label "Firmware Version *.* dated ******" :bold T
}
     :hskip 60
     :checkbox ALL-MODULES :label "Act on ALL Boards?"  :value $allmodules
if {$UserGUIVersion != 2} {     ;#   MWD firmware
    :next-row T
     :hskip 300
     :message VERSION :label "Firmware Version *.* dated ******" :bold T
     :hskip 80
     :checkbox ALL-CHANS   :label "Act on ALL Channels?" :value $allchans
}
     :next-row T
      set menu {All}
      for {set i 1} {$i <= $numchans} {incr i} {lappend menu $i}
     :choice APPLY :label "Apply settings to channels(s)" :strings $menu :w 3 :exclusive F
     :button EXECUTE :label "Execute"

if {$UserGUIVersion == 1} {   
   :container C0 :layout T

   :panel P0R :layout R :padx 0 :pady 0
     :layout V; :row-gap 10; :col-gap 10  

    set Customcfgfile $Options(FpgaRegisters)

    set z [catch {open $Customcfgfile r} f]
    if {$z != 0} then {
          midas-warning "Cannot read file $Customcfgfile\n$f"
          return
    }
    set Usercfg [split [read $f] \n]
    close $f

    for {set i 0} {$i <= 31} {incr i} {set RegMask($i) 0x0000ffff}

#    process configuration file

    set UserReg {}

    foreach item $Usercfg {
       if {[string range $item 0 0] == "#"} {continue}
       if {[first $item] == "name"} {continue}
       switch [first $item] {
           choice  {
               set ID [second [split [third $item] =]]
               lappend UserReg $ID
               set options [lreplace $item 0 2]
               set menu {}
               foreach element $options {
                   lappend menu [second [split $element :]]
               }
               :choice MWDR$ID :label "[second $item]" :strings $menu  :valuex 15c
               :next-row T
           }
           slider {
               set ID [second [split [third $item] =]]
               lappend UserReg $ID
               set Units [second [split [lindex $item 3] =]]
               set Range [second [split [lindex $item 4] =]]
               set min [first [split $Range ,]]
               set max [second [split $Range ,]]
               :slider MWDR$ID :label "[second $item]" :min [second [split $min :]] :max [second [split $max :]]  :valuex 15c
               :next-row T
           }
           value {
               set ID [second [split [third $item] =]]
               lappend UserReg $ID
               :text MWDR$ID :label "[second $item]" :w 12 :valuex 15c
               :next-row T
           }
           default {}
       }
    }

   :container end
}

   :panel P1 :layout B :padx 5 :pady 5   :after FOOTER
     :layout H; :row-gap 10; :col-gap 10

      :text USER91          :label "User Register 1" :inactive T :w 12
      :choice-stack USER910 :label "Chan Index" :value $user10 :strings $Menu1 :valuex 12c
      :choice-stack USER911 :label "register address" :value $user11 :strings $Menu2 :valuex 16c
      :text USER912         :label "register value" :w 8 :value $user12 :valuex 12c
      :button USER913       :label "Write"
      :next-row T

      :text USER92          :label "User Register 2" :inactive T :w 12
      :choice-stack USER920 :label "Chan Index" :value $user90 :strings $Menu1 :valuex 12c
      :choice-stack USER921 :label "register address" :value $user91 :strings $Menu2 :valuex 16c
      :text USER922         :label "register value" :w 8 :value $user92 :valuex 12c
      :button USER923       :label "Read"
      :next-row T

   :panel BUTTONS :layout B :padx 5 :pady 5  :after FOOTER
     :layout H; :row-gap 10; :col-gap 10

      :button USERDONE  :label "Done" :command "frame-quit [self frame-name].user"
      :button USERUPDTE :label "Update" :command update_UserGUI

  :show T

   update_UserGUI
}

proc update_UserGUI {} {
    global boardID BoardNum CrateNum WriteIF ReadIF 
    global boardlist maxboards
    global UserGUIVersion

    :modify [self frame-name].user :busy T

    :modify CRT-NUM :value $CrateNum
    set boardmenu {}
    for {set i 1} {$i <= $maxboards} {incr i} {lappend boardmenu $i}
    :modify MOD-SEL :menu $boardmenu
    :modify MOD-NUM :min 1 :max $maxboards
    :modify MOD-NUM :value [expr 1 + $boardID]

if {$UserGUIVersion != 2} {  
    global ChanNum
    :modify CHAN-NUM :value $ChanNum
}

    set rc [VHSADCClient__Vhsadac16ReadFpgaReg $boardID $WriteIF]  ;# user register
    :modify USER91  :inactive F :value [format 0x%08x $rc] :inactive T

    set rc [VHSADCClient__Vhsadac16ReadFpgaReg $boardID $ReadIF]  ;# user register
    :modify USER92  :inactive F :value [format 0x%08x $rc] :inactive T

    set registers {}
    lappend registers [expr (0x80 << 16)]      ;#  Major Release Version
    lappend registers [expr (0x81 << 16)]      ;#  Minor Release Version
    lappend registers [expr (0x83 << 16)]      ;#  date

#        set-footer [self frame-name].user "Reading board registers"
        set values [ReadUserRegs $boardID $registers]

        set day   [expr 0x[string range [lindex $values 2] 4 5]]
        set month [expr 0x[string range [lindex $values 2] 6 6]]
        set year  [expr 0x[string range [lindex $values 2] 7 7] + 2000]
        :modify VERSION :label "Firmware Version [expr [lindex $values 0] & 0x0000ffff].[expr [lindex $values 1] & 0x0000ffff] dated $day/$month/$year"

if {$UserGUIVersion != 2} {
     global UserReg
     Read_MWD_Registers
     foreach reg $UserReg {
        global MWDr$reg
       :modify MWDR$reg :value [set MWDr$reg]
     }
}

    :modify [self frame-name].user :busy F
}

proc Set_MWD_Registers {} {}
proc Read_MWD_Registers {} {}
proc redisplay_mwd_parameters {} {}

